<template>
  <b-card :header="title" header-tag="header" footer-tag="small" footer-text-variant="muted" :class="classes" no-body>
    <b-card-body :title="value" :sub-title="info" title-tag="h2" sub-title-tag="small" class="pt-0 pb-0">
      <icon v-if="showIcon" :name="icon" :square="46" class="metric-icon" :stroke-width="1"/>
    </b-card-body>

    <b-progress v-if="type === 'progress'" :value="metric"/>

    <chart v-else-if="type === 'chart'" class="metric-chart" :data="metric.data" :options="metric.options"/>
  </b-card>
</template>

<script>
import Chart from './chart'

export default {
  name: 'metric',

  components: { Chart },

  props: {
    title: {
      type: String,
      required: true
    },
    data: {
      type: [String, Number, Array, Object],
      required: true
    },
    info: String,
    icon: String
  },

  computed: {
    classes () {
      const classes = ['metric', `type-${this.type}`]

      return classes
    },

    value () {
      return this.normalizeTitle(this.data)
    },

    metric () {
      if (this.type === 'progress') {
        return (this.data[0] / this.data[1]) * 100
      }
      const axis = {
        offset: 0,
        showLabel: false,
        showGrid: false
      }

      return {
        data: Object.assign({}, {
          labels: this.data.labels,
          series: this.data.series
        }),

        options: {
          low: 0,
          fullWidth: true,
          showArea: true,
          height: 40,
          // width: '100%'
          chartPadding: {
            top: 0,
            right: 3,
            bottom: 0,
            left: 3
          },
          axisY: axis,
          axisX: axis
        }
      }
    },

    type () {
      switch (this.data.constructor.name) {
        case 'Array':
          return 'progress'
        case 'Object':
          return 'chart'
        default:
          return 'basic'
      }
    },

    showIcon () {
      return this.icon.length > 0
    }
  },

  methods: {
    normalizeTitle (title) {
      switch (title.constructor.name) {
        case 'Number':
          return title.toLocaleString('id')
        case 'Array':
          return title.join('/')
        case 'Object':
          return this.normalizeTitle(title.value)
        default:
          return title
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.card-header {
  border-bottom: 0;
  background-color: transparent;
  text-transform: uppercase;
  font-size: 12px;
}

.card-title {
  color: $primary;
  line-height: 1em;
}

.progress {
  box-shadow: none;
  border-top-left-radius: 0;
  border-top-right-radius: 0;

  /deep/ &-bar {
    background-color: $primary;
  }
}

.metric {
  // &.type-line-chart .card-body {
  //   padding-bottom: 0;
  // }

  .ct-chart-pie,
  .ct-chart-donut,
  &-icon {
    position: absolute;
    top: 1rem;
    right: 1rem;
    color: $primary;
  }

  &-icon /deep/ svg {
    @include media-breakpoint-between(sm, md) {
      width: 24px;
      height: 24px;
    }
  }

  &-chart {
    margin-left: -4px;
    margin-right: -3px;
  }
}
</style>
